# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:          # List of stages for jobs, and their order of execution
  - build
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  variables:
    IMAGE_PATH: image/
    IMAGE_NAME: app_${CI_COMMIT_BRANCH}_${CI_COMMIT_SHORT_SHA}.bin
  script:
    - echo "Compiling the code for ${IMAGE_PATH}${IMAGE_NAME}"
    - mkdir -p ${IMAGE_PATH}
    - touch ${IMAGE_PATH}${IMAGE_NAME}
    - touch CHANGELOG.MD
    - ls
    - ls ${IMAGE_PATH}
    - echo "Compile complete."
    - echo "APP_IMAGE_PATH=${IMAGE_PATH}${IMAGE_NAME}" >> artifacts.env
    - cat artifacts.env
  artifacts:
      paths:
        - CHANGELOG.MD
        - ${IMAGE_PATH}${IMAGE_NAME}
      reports:
        dotenv: artifacts.env

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  needs:
      - build-job
  variables:
    GIT_STRATEGY: none
  script:
    - echo "Found build artefact ${APP_IMAGE_PATH}"
    - ls
    - ls image/
    - echo "Deploying application..."
    - echo "Application successfully deployed."
